-- Ini-File Operations by AuahDark

function GetLocationString(tab,str)
	for n,v in pairs(tab) do
		if v==str then
			return n
		end
	end
	return nil
end

function ReParseString(str)
	local tmp={}
	for w in str:gmatch(".") do
		table.insert(tmp,w)
	end
	return tmp
end

function FixString(str)
	local tmp=ReParseString(str)
	local data=#tmp+1
	for i=#tmp,1,-1 do
		if tmp[i]:byte()<=32 or tmp[i]:byte()==255 then
			data=i
		else
			break
		end
	end
	local val=str:sub(1,data-1)
	return tonumber(val) or val
end

function ini_get(filename,key)
	key=key:gsub(";","")
	local f=io.open(filename,"r")
	if f then
		for line in f:lines() do
			local tmp=ReParseString(line)
			line=FixString(line:sub(1,GetLocationString(tmp,";")-1 or #line))
			if line:sub(1,#key)==key then
				local value=line:sub(#key+2)
				f:close()
				if value=="true" then return true
				elseif value=="false" then return false
				elseif not tonumber(value) then
					return value
				else
					return tonumber(value)
				end
			end
		end
		return ""
	else
		error("ini_get: Cannot read from file: "..filename,2)
	end
end

function ini_set(filename,key,value)
	local f=io.open(filename,"r")
	local list={}
	key=key:gsub(";","")
	value=FixString(tostring(value):gsub(";","\\;"))
	if f then
		for line in f:lines() do
			for n,v in line:gmatch("(%w+)=(%w+)") do
				list[n]=v
			end
		end
		f:close()
	else
		io.open(filename,"w"):close()
	end
	list[key]=value
	f=io.open(filename,"w")
	local tmpstr=""
	for n,v in pairs(list) do
		tmpstr=tmpstr..n.."="..v.."\r\n"
	end
	tmpstr=tmpstr:sub(1,-3)
	f:write(tmpstr)
	f:close()
end